#pragma semicolon 1

#include <sourcemod>
#include <sdktools_functions>

public Plugin:myinfo = 
{
	name	= "Bomb Radius",
	author	= "wS",
	version = "1.0.1"
};

new Handle:g_hCvar;
new g_ref = INVALID_ENT_REFERENCE;
new bool:g_bC4Map;

public OnPluginStart()
{
	g_hCvar = CreateConVar("bomb_radius", "1", "Радиус взрыва бомбы на de_ картах (0 стандарт)", _, true, 0.0, true, 2048.0);
	HookConVarChange(g_hCvar, CvarChanged);
}

public CvarChanged(Handle:hCvar, const String:OldValue[], const String:NewValue[]) ChangeRadius(StringToInt(NewValue));
public OnConfigsExecuted() ChangeRadius(GetConVarInt(g_hCvar));
public OnMapStart() g_bC4Map = FindEntityByClassname(-1, "func_bomb_target") > MaxClients;

ChangeRadius(radius)
{
	if (!g_bC4Map || radius < 0 || radius > 2048)
		return;
	
	new entity = EntRefToEntIndex(g_ref);
	if (radius == 0)
	{
		if (entity > MaxClients)
			DispatchKeyValue(entity, "bombradius", "500");
	}
	else
	{
		decl String:s[12];
		IntToString(radius, s, sizeof(s));
		if (entity > MaxClients || (entity = FindEntityByClassname(-1, "info_map_parameters")) > MaxClients)
		{
			DispatchKeyValue(entity, "bombradius", s);
		}
		else if ((entity = CreateEntityByName("info_map_parameters")) > MaxClients)
		{
			DispatchKeyValue(entity, "bombradius", s);
			DispatchSpawn(entity);
		}
		else
		{
			LogError("CreateEntityByName error: info_map_parameters");
			return;
		}
		g_ref = EntIndexToEntRef(entity);
	}
}